﻿@model I3Teck.AndonAlarm.ViewModels.AndonReportsViewModel
@{
    ViewData["Title"] = "Andon Alarm Statistics";
}

<div class="m-grid__item m-grid__item--fluid m-grid m-grid--ver-desktop m-grid--desktop m-body" style="background: transparent !important; margin-top: 3vw">
    <div class="m-grid__item m-grid__item--fluid m-wrapper">
        <div class="col-md-12" style="padding-right: 65px !important; padding-left: 65px !important;">
            <div class="m-portlet m-portlet--creative_tegra  m-portlet--first m-portlet--bordered-semi">
                <div class="m-portlet__head">
                    <div class="m-portlet__head-caption">
                        <div class="m-portlet__head-title">
                            <h3 class="m-portlet__head-text"></h3>
                            <h2 class="m-portlet__head-label m-portlet__head-label--danger">
                                <span>@ViewData["Title"]</span>
                            </h2>
                        </div>
                    </div>
                </div>
                <div class="m-portlet__body">
                    <div class="col-12">
                        <div class="row">
                            <div class="col-9">
                                <div class="m-widget4 row ">
                                    <div class="col-lg-3 col-md-3 col-sm-6 col-xs-12">
                                        <a class="dashboard-stat dashboard-stat-v2 red" href="#">
                                            <div class="visual">
                                                <i class="fa fa-exclamation-circle"></i>
                                            </div>
                                            <div class="details">
                                                <div class="number">
                                                    <span class="counter" id="alerted">0</span>
                                                </div>
                                                <div class="desc">Alerted Lines</div>
                                            </div>
                                        </a>
                                    </div>
                                    <div class="col-lg-3 col-md-3 col-sm-6 col-xs-12">
                                        <a class="dashboard-stat dashboard-stat-v2 red" style="background-color: orange" href="#">
                                            <div class="visual">
                                                <i class="fa fa-exclamation-triangle"></i>
                                            </div>
                                            <div class="details">
                                                <div class="number">
                                                    <span class="counter" id="warning">0</span>
                                                </div>
                                                <div class="desc">Warning Lines</div>
                                            </div>
                                        </a>
                                    </div>
                                    <div class="col-lg-3 col-md-3 col-sm-6 col-xs-12">
                                        <a class="dashboard-stat dashboard-stat-v2 red" style="background-color: darkgray" href="#">
                                            <div class="visual">
                                                <i class="fa fa-cloud"></i>
                                            </div>
                                            <div class="details">
                                                <div class="number">
                                                    <span class="counter" id="workless">0</span>
                                                </div>
                                                <div class="desc">Workless Lines</div>
                                            </div>
                                        </a>
                                    </div>
                                    <div class="col-lg-3 col-md-3 col-sm-6 col-xs-12">
                                        <a class="dashboard-stat dashboard-stat-v2 red" style="background-color: green" href="#">
                                            <div class="visual">
                                                <i class="fa fa-check-circle"></i>
                                            </div>
                                            <div class="details">
                                                <div class="number">
                                                    <span class="counter" id="unalerted">0</span>
                                                </div>
                                                <div class="desc">Unalerted Lines</div>
                                            </div>
                                        </a>
                                    </div>

                                </div>
                                <div class="m-widget4 row ">
                                    <div class="m-portlet__body" style="width: 100%;">
                                        <form asp-action="ReportAlertTable" id="ReportSubmit">
                                            <div class="row">
                                                <div class="col-3">
                                                    <div class="form-group row text-right">
                                                        <label asp-for="Factory" class="control-label col-2"></label>
                                                        <div class="col-10">
                                                            <select asp-for="Factory" asp-items="Model.FactoryList" class="form-control"></select>
                                                            <span asp-validation-for="Factory" class="text-danger"></span>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="col-3">
                                                    <div class="form-group row text-right">
                                                        <label asp-for="Process" class="control-label col-2"></label>
                                                        <div class="col-10">
                                                            <select asp-for="Process" asp-items="Model.ProcessList" class="form-control"></select>
                                                            <span asp-validation-for="Process" class="text-danger"></span>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="col-4">
                                                    <div class="form-group row text-right">
                                                        <label asp-for="Week" class="control-label col-2"></label>
                                                        <div class="col-9">
                                                            <select asp-for="Week" asp-items="Model.WeekList" class="form-control"></select>
                                                            <span asp-validation-for="Week" class="text-danger"></span>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="col-2">
                                                    <button id="buttonSubmit"  type="submit" class="btn btn-tegra m-btn m-btn--pill m-btn--custom m-btn--air">Submit</button>

                                                </div>
                                                <div >

                                                </div>
                                            </div>
                                        </form>
                                       
                                    </div>
                                </div>
                                <div class="m-widget4 row ">

                                    <div class="m-portlet__body" style="width: 100%;">
                                        <div class="m--align-right">
                                            <div class="m-separator m-separator--dashed d-xl-none"></div>
                                        </div>
                                        <div class="m-portlet__body" style="width: 100%;" id="container">
                                            <div id="table-search" class="dataTables_filter float-right">
                                                <label id="label-search" style="display: none">
                                                    Search:&nbsp;&nbsp;
                                                    <input id="search" type="search" autocomplete="off">
                                                </label>
                                            </div>
                                            <div id="excel-icon" class="dataTables_filter float-left">
                                            </div>
                                            
                                            <div id="table">
                                            </div>
                                        </div>
                                    </div>
                                    </div>
                            </div>
                            <div class="col-3">
                                <div id="chartAlerted"></div>
                                <div id="chart"></div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>

@section Style
{
    <link rel="stylesheet" type="text/css" href="~/assets/css/dataTables.min.css">
    <link rel="stylesheet" type="text/css" href="~/assets/css/buttons.dataTables.min.css">
    <link href="~/assets/css/components.min.css" rel="stylesheet"/>
    <style>
        .counter { }
    </style>
}

@section Scripts
{
    <script type="text/javascript" language="javascript" src="~/assets/scripts/jquery.waypoints.min.js"></script>
    <script type="text/javascript" language="javascript" src="~/assets/scripts/counterup.jquery.js"></script>
    <script type="text/javascript" language="javascript" src="~/assets/scripts/dataTables.min.js"></script>
    <script type="text/javascript" language="javascript" src="~/assets/scripts/dataTables.buttons.min.js"></script>
    <script type="text/javascript" language="javascript" src="~/assets/scripts/apexcharts.min.js"></script>
    <script src="~/assets/scripts/ajaxPagination.js?ts=1"></script>
    <script type="text/javascript" language="javascript">
        $(document).ready(function() {
            var table = $("#table");
            var routeTable = "/andonReports/ReportAlertTable";
            var container = $("#container");
            var search = $("#search");
            var minLength = 2;
            var form = $("#ReportSubmit");
            var factory = $('#Factory');
            var process = $('#Process');
            var week = $('#Week');
            var lastFilter = "";

            var getCurrentFilter = function(route) {
                var delimiter = (route.indexOf('?') === -1) ? '?' : '&';
                if (search.val().length >= 2) {
                        
                    return route + delimiter + 'search=' + search.val() + '&' + form.serialize();
                } else {
                    return route + delimiter + form.serialize();

                }
            }
          
            paginate.init(table, routeTable, container, search);
            form.on('submit',
                function(e) {
                    e.preventDefault();
                    var form = $(this);
                    lastFilter = getCurrentFilter("");
                    paginate.load(function(route) {
                        var delimiter = (route.indexOf('?') === -1) ? '?' : '&';
                        GetAlertedLines();
                        return route + delimiter + form.serialize();
                    });
                });
            function delay(callback, ms) {
                var timer = 0;
                return function() {
                    var context = this, args = arguments;
                    clearTimeout(timer);
                    timer = setTimeout(function () {
                        callback.apply(context, args);
                    }, ms || 0);
                };
            }

            $('#search').off('keyup');
            $('#search').keyup(delay(function () {
                clearTimeout(2000);
                var filter = getCurrentFilter("");
                lastFilter = filter;
                paginate.load(getCurrentFilter);
            },500));
        });


        function GetAlertedLines() {
            var factory = $('#Factory').val();
            var process = $('#Process').val();
            var week = $('#Week').val();

            $('.counter').counterUp({
                delay: 10,
                time: 1000
            });

            $.ajax({
                type: "POST",
                url: "/AndonReports/ReportAlertDetailsCharts",
                data: { factoryId: factory, processId: process, weekId: week },
                success: function(data) {
                    $("#alerted").empty();
                    $("#warning").empty();
                    $("#workless").empty();
                    $("#unalerted").empty();
                    var alertTypes = alertByType(data);
                    var alertedLines = alertTypes.alerted.map(x => x.line)
                        .filter((value, index, self) => self.indexOf(value) === index);
                    var warningLines = alertTypes.warnings.map(x => x.line)
                        .filter((value, index, self) => self.indexOf(value) === index);
                    var worklessLines = alertTypes.workless.map(x => x.line)
                        .filter((value, index, self) => self.indexOf(value) === index);
                    var notAlertedLines = data.totalLines -
                        (alertedLines.length + warningLines.length + worklessLines.length);
                    $("#alerted").append(alertedLines.length);
                    $("#warning").append(warningLines.length);
                    $("#workless").append(worklessLines.length);
                    $("#unalerted").append(notAlertedLines);
                    $(".counter").counterUp();
                    console.log(data.alertReportDetails);
                    if (data.alertReportDetails.length > 0) {
                        $("#unalerted").append();
                        buildChartAlerts(data);
                        buildChartLinesAlerted(data);
                        $('#search').value = '';
                        $("#excel-icon").empty();
                        $("#excel-icon").append(
                            '<label>Export to Excel</label><a href="/andonReports/ExcelReportByWeek?factoryId=' +
                            factory +
                            '&processId=' +
                            process +
                            '&weekId=' +
                            week +
                            '"><img src="assets/img/excel-icon.png" height="45" width="60"/></a>');
                        $('#label-search').css({ display: "inline" });
                    } else {
                        $("#chart").empty();
                        $("#chartAlerted").empty();
                        $("#excel-icon").empty();
                        $("#alerted").empty();
                        $("#warning").empty();
                        $("#workless").empty();
                        $("#unalerted").empty();
                        $('#label-search').css({ display: "none" });

                    }
                }
            });
        };

        function buildChartAlerts(data) {
            var alertType = alertByType(data);
            $("#chart").empty();
            var options = {
                chart: {
                    width: 450,
                    type: 'donut'
                },
                title: {
                    text: 'Number of alerts type',
                    align: 'center',
                    margin: 15,
                    offsetX: 0,
                    offsetY: 0,
                    floating: false,
                    style: {
                        fontSize: '14px',
                        color: 'black'
                    }
                },
                labels: ['Alerts ', 'Warnings ', 'Workless '],
                series: [alertType.alerted.length, alertType.warnings.length, alertType.workless.length],
                colors: ['#d83f45', '#f78624', '#a9a9a9'],
                responsive: [
                    {
                        breakpoint: 480,
                        options: {
                            chart: {
                                width: 200
                            },
                            legend: {
                                position: 'bottom'
                            }
                        }
                    }
                ]
            }
            var chart = new ApexCharts(
                document.querySelector("#chart"),
                options
            );
            chart.render();
        }

        function buildChartLinesAlerted(data) {
            $("#chartAlerted").empty();
            var alertTypes = alertByType(data);
            var alertedLines = alertTypes.alerted.map(x => x.line)
                .filter((value, index, self) => self.indexOf(value) === index);
            var warningLines = alertTypes.warnings.map(x => x.line)
                .filter((value, index, self) => self.indexOf(value) === index);
            var worklessLines = alertTypes.workless.map(x => x.line)
                .filter((value, index, self) => self.indexOf(value) === index);
            var notAlertedLines = data.totalLines - (alertedLines.length + warningLines.length + worklessLines.length);
            var options = {
                chart: {
                    width: 450,
                    type: 'donut',
                    plotOptions: {
                        pie: {
                            donut: {
                                size: '65%',
                                total: {
                                    show: true,
                                    label: 'Total',
                                    color: '#373d3f'
                                }
                            }
                        }
                    }
                },
                title: {
                    text: 'Number Of lines with Alerts',
                    align: 'center',
                    margin: 15,
                    offsetX: 0,
                    offsetY: 0,
                    floating: false,
                    style: {
                        fontSize: '14px',
                        color: 'black'
                    }
                },

                total: data.totalLines,
                labels: ['Alerted ', 'Warning ', 'Workless ', 'Not alerted Lines'],
                series: [alertedLines.length, warningLines.length, worklessLines.length, notAlertedLines],
                colors: ['#d83f45', '#f78624', '#a9a9a9', '#067302'],
                responsive: [
                    {
                        breakpoint: 480,
                        options: {
                            chart: {
                                width: 200
                            },
                            legend: {
                                show: true,
                                position: 'bottom'
                            }
                        }
                    }
                ]
            }
            var chart = new ApexCharts(
                document.querySelector("#chartAlerted"),
                options
            );
            chart.render();
        }

        function alertedLinesNumber(data) {
            debugger;
            var alerted = data.alerted.map(x => x.line).filter((value, index, self) => self.indexOf(value) === index);
            var warning = data.warnings.map(x => x.line).filter((value, index, self) => self.indexOf(value) === index);
            var workless = data.workless.map(x => x.line).filter((value, index, self) => self.indexOf(value) === index);
            var notAlerted = data.totalLines - (alertedLines.length + warningLines.length + worklessLines.length);
            var result = {
                alertedLines: alerted,
                warningLines: warning,
                worklessLines: workless,

            }
            return result;
        }

        function alertByType(data) {
            var alerts = data.alertReportDetails.filter(x => x.alertType == 1);
            var warnings = data.alertReportDetails.filter(x => x.alertType == 2);
            var workless = data.alertReportDetails.filter(x => x.alertType == 3);
            var result = {
                alerted: alerts,
                warnings: warnings,
                workless: workless
            }
            return result;
        }


    </script>
}